# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1
%define jruid 499

Name:           jackrabbit21
Version:        2.1.6
Release:        4%{?dist}
Epoch:          0
Summary:        Apache Jackrabbit JCR 2.0 Implementation
License:        Apache Software License 2.0
Url:            http://jackrabbit.apache.org/
Group:          Development/Libraries/Application Frameworks
Source0:        http://www.apache.org/dist/jackrabbit/%{version}/jackrabbit-%{version}-src.zip

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}.init
Source4:        %{name}.conf
Source5:        %{name}.wrapper

Patch0:         %{name}-JackrabbitParser.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  apache-rat
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  mojo-build-helper-maven-plugin
BuildRequires:  mojo-cobertura-maven-plugin
BuildRequires:  mojo-javacc-maven-plugin
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  derby
BuildRequires:  h2database
BuildRequires:  jackrabbit-parent
BuildRequires:  james-project
BuildRequires:  geronimo-genesis

BuildRequires:  apache-mime4j
BuildRequires:  apache-pdfbox
BuildRequires:  apache-tika >= 0:1.0
BuildRequires:  bouncycastle
BuildRequires:  boilerpipe
BuildRequires:  concurrent
BuildRequires:  geronimo-jta-1.0.1B-api
BuildRequires:  jackrabbit-jcr-benchmark
BuildRequires:  jcr_2_0_api
BuildRequires:  jetty6
BuildRequires:  jetty6-jsp-2.1
BuildRequires:  j2ee_connector_1_5_api
BuildRequires:  lucene24
BuildRequires:  netcdf-java
BuildRequires:  rome
BuildRequires:  servlet_2_5_api
BuildRequires:  slf4j
BuildRequires:  stax_1_0_api

Requires:       apache-commons-chain
Requires:       apache-commons-cli
Requires:       apache-commons-collections
Requires:       apache-commons-dbcp
Requires:       apache-commons-fileupload
Requires:       apache-commons-httpclient
Requires:       apache-commons-io
Requires:       apache-commons-jexl
Requires:       apache-pdfbox
Requires:       apache-tika
Requires:       concurrent
Requires:       j2ee_connector_1_5_api
Requires:       jcr_2_0_api
Requires:       jetty6
Requires:       jetty6-jsp-2.1
Requires:       jline
Requires:       jta_1_0_1B_api
Requires:       lucene24
Requires:       servlet_2_5_api
Requires:       slf4j
Requires:       tagsoup
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
Apache Jackrabbit is a fully conforming implementation of 
the Content Repository for Java Technology API (JCR, 
specified in JSR 170 and 283).
A content repository is a hierarchical content store with 
support for structured and unstructured content, full text 
search, versioning, transactions, observation, and more.
Apache Jackrabbit is a project of the Apache Software 
Foundation.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n jackrabbit-%{version}
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;

%patch0 -b .sav0

%build
cp %{SOURCE1} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

export MAVEN_OPTS="-Xmx512m -Dproject.build.directory=target -Dproject.build.outputDirectory=target/classes"

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 
#       -Dmaven.test.skip=true \
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 jackrabbit-api/target/jackrabbit-api-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
install -m 644 jackrabbit-api/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-api %{version} JPP/%{name} api

install -m 644 jackrabbit-core/target/jackrabbit-core-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 jackrabbit-core/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-core %{version} JPP/%{name} core

install -m 644 jackrabbit-jca/target/jackrabbit-jca-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jca-%{version}.jar
install -m 644 jackrabbit-jca/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jca.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jca %{version} JPP/%{name} jca

install -m 644 jackrabbit-jcr2dav/target/jackrabbit-jcr2dav-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr2dav-%{version}.jar
install -m 644 jackrabbit-jcr2dav/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr2dav.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr2dav %{version} JPP/%{name} jcr2dav

install -m 644 jackrabbit-jcr2spi/target/jackrabbit-jcr2spi-%{version}-tests.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr2spi-tests-%{version}.jar
install -m 644 jackrabbit-jcr2spi/target/jackrabbit-jcr2spi-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr2spi-%{version}.jar
install -m 644 jackrabbit-jcr2spi/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr2spi.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr2spi %{version} JPP/%{name} jcr2spi

install -m 644 jackrabbit-jcr-client/target/jackrabbit-jcr-client-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-client-%{version}.jar
install -m 644 jackrabbit-jcr-client/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr-client.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr-client %{version} JPP/%{name} jcr-client

install -m 644 jackrabbit-jcr-commons/target/jackrabbit-jcr-commons-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-commons-%{version}.jar
install -m 644 jackrabbit-jcr-commons/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr-commons.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr-commons %{version} JPP/%{name} jcr-commons

install -m 644 jackrabbit-jcr-rmi/target/jackrabbit-jcr-rmi-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-rmi-%{version}.jar
install -m 644 jackrabbit-jcr-rmi/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr-rmi.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr-rmi %{version} JPP/%{name} jcr-rmi

install -m 644 jackrabbit-jcr-server/target/jackrabbit-jcr-server-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-server-%{version}.jar
install -m 644 jackrabbit-jcr-server/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr-server.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr-server %{version} JPP/%{name} jcr-server

install -m 644 jackrabbit-jcr-servlet/target/jackrabbit-jcr-servlet-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-servlet-%{version}.jar
install -m 644 jackrabbit-jcr-servlet/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr-servlet.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr-servlet %{version} JPP/%{name} jcr-servlet

install -m 644 jackrabbit-jcr-tests/target/jackrabbit-jcr-tests-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-tests-%{version}.jar
install -m 644 jackrabbit-jcr-tests/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jcr-tests.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-jcr-tests %{version} JPP/%{name} jcr-tests

install -m 644 jackrabbit-spi2dav/target/jackrabbit-spi2dav-%{version}-tests.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi2dav-tests-%{version}.jar
install -m 644 jackrabbit-spi2dav/target/jackrabbit-spi2dav-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi2dav-%{version}.jar
install -m 644 jackrabbit-spi2dav/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi2dav.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-spi2dav %{version} JPP/%{name} spi2dav

install -m 644 jackrabbit-spi2jcr/target/jackrabbit-spi2jcr-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi2jcr-%{version}.jar
install -m 644 jackrabbit-spi2jcr/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi2jcr.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-spi2jcr %{version} JPP/%{name} spi2jcr

install -m 644 jackrabbit-spi-commons/target/jackrabbit-spi-commons-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi-commons-%{version}.jar
install -m 644 jackrabbit-spi-commons/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi-commons.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-spi-commons %{version} JPP/%{name} spi-commons

install -m 644 jackrabbit-spi/target/jackrabbit-spi-%{version}-tests.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi-tests-%{version}.jar
install -m 644 jackrabbit-spi/target/jackrabbit-spi-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi-%{version}.jar
install -m 644 jackrabbit-spi/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-spi %{version} JPP/%{name} spi

install -m 644 jackrabbit-standalone/target/jackrabbit-standalone-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/standalone-%{version}.jar
install -m 644 jackrabbit-standalone/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-standalone.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-standalone %{version} JPP/%{name} standalone

install -m 644 jackrabbit-webapp/target/jackrabbit-webapp-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webapp-%{version}.jar
install -m 644 jackrabbit-webapp/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-webapp.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-webapp %{version} JPP/%{name} webapp

install -m 644 jackrabbit-webdav/target/jackrabbit-webdav-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webdav-%{version}.jar
install -m 644 jackrabbit-webdav/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-webdav.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-webdav %{version} JPP/%{name} webdav

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jackrabbit.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit %{version} JPP/%{name} jackrabbit

install -m 644 jackrabbit-parent/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-parent %{version} JPP/%{name} parent

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 jackrabbit-jca/target/jackrabbit-jca-%{version}.rar \
        $RPM_BUILD_ROOT%{_datadir}/%{name}/jca-%{version}.rar
install -m 644 jackrabbit-webapp/target/jackrabbit-webapp-%{version}.war \
        $RPM_BUILD_ROOT%{_datadir}/%{name}/webapp-%{version}.war
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jackrabbit/log

# init
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/init.d
%{__install} -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/init.d/%{name}
# conf
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
%{__install} -m 0644 %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/%{name}.conf
# logdir
install -d -m 755 $RPM_BUILD_ROOT%{_var}/log/%{name}
#wrapper
install -d -m 755 $RPM_BUILD_ROOT%{_sbindir}
%{__install} -m 755 %{SOURCE5} ${RPM_BUILD_ROOT}%{_sbindir}/d%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# add the jackrabbit user and group
%{_sbindir}/groupadd -g %{jruid} -r jackrabbit 2>/dev/null || :
%{_sbindir}/useradd -c "Apache Jackrabbit" -u %{jruid} -g jackrabbit \
    -s /bin/sh -r -d %{_datadir}/%{name} jackrabbit 2>/dev/null || :

%post
%update_maven_depmap
chmod -R 0775 %{_datadir}/%{name}/jackrabbit

%postun
%update_maven_depmap


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%attr(0755,root,root) %{_sysconfdir}/init.d/%{name}
%attr(0755,root,root) %{_sbindir}/d%{name}
%{_sysconfdir}/%{name}
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.rar
%{_datadir}/%{name}/*.war
%dir %attr(0775,root,jackrabbit) %{_datadir}/%{name}/jackrabbit
%dir %attr(0775,root,jackrabbit) %{_datadir}/%{name}/jackrabbit/log
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%dir %{_var}/log/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Sat Feb 16 2013 Ralph Apel <r.apel at r-apel.de> 0:2.1.6-4
- Fix CFG variable name

* Thu Feb 14 2013 Ralph Apel <r.apel at r-apel.de> 0:2.1.6-3
- Create and use "jackrabbit" OS user
- Add start script for standalone server

* Wed Feb 06 2013 Ralph Apel <r.apel at r-apel.de> 0:2.1.6-2
- Prevent xzpayload problem

* Tue Jan 29 2013 Ralph Apel <r.apel at r-apel.de> 0:2.1.6-1
- 2.1.6 as jackrabbit21 patched to tika 1.0

* Tue Sep 28 2010 Ralph Apel <r.apel at r-apel.de> 0:2.1.0-1
- 2.1.0 as jackrabbit2 (JCR-2.0 implemented)

* Sat Nov 28 2009 Ralph Apel <r.apel at r-apel.de> 0:1.5.7-1
- 1.5.7

* Fri Jun 27 2008 Ralph Apel <r.apel at r-apel.de> 0:1.4-1.jpp5
- 1.4

* Mon Oct 24 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.r321061.2jpp
- Downgrade Requirement to spring11

* Wed Oct 19 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.r321061.1jpp
- First build from this codebase
